################################################## Useul Functions ##################################################

def iszero(data):
    if data == 0 and data is not False and data is not None:
        return True
    else:
        return False

################################################## Loading a room ##################################################
def room_loaded(event):
    # The map will be blocked on a per-room basis, so unblock the map for now.
    # It may be re-blocked later in the loading process.
    map_unblock()

    #Startup
    if event=="Startup":
        overlay_set_transparency(0)
        overlay_fade(1)
        map_refresh()
        map_target_refresh()
        inventory_refresh(False)
        if savegame_value('Inventory','Cilia (Fairy)') == 1:
            fairies_create_cilia()
        if savegame_value('Inventory','Dora (Fairy)') == 1:
            fairies_create_dora()
        if savegame_value('Inventory','Niles (Fairy)') == 1:
            fairies_create_niles()
        if savegame_value('Inventory','Rob (Fairy)') == 1:
            fairies_create_rob()
        if savegame_value('Inventory','Ethan (Fairy)') == 1:
            fairies_create_ethan()

    if room_y() <= 29:
        # Create borders to prevent player to enter non-existing rooms
        if not room_exists(room_x()  ,room_y()-1): border_create('Top')
        if not room_exists(room_x()+1,room_y()  ): border_create('Right')
        if not room_exists(room_x()  ,room_y()+1): border_create('Bottom')
        if not room_exists(room_x()-1,room_y()  ): border_create('Left')

        # Reveal this room on the map
        map_reveal(room_x(),room_y(),True)
        map_roomtype_reveal(room_x(),room_y())

        # Mark this room on the map
        map_player_set_visibility(True)
        map_player_move(room_x(),room_y())

    else:
        # Don't show player
        map_reveal(room_x(),room_y(),True)
        map_roomtype_reveal(room_x(),room_y())
        map_player_set_visibility(True)
        map_player_move(room_x(),room_y())

    # Remove collected pixie objects
    if savegame_string('Collected Pixies', str(room_x()) + ',' + str(room_y())) is not False:
        sprite_delete('Function',savegame_string('Collected Pixies', str(room_x()) + ',' + str(room_y())))
        sprite_delete('Simple Animation',savegame_string('Collected Pixies', str(room_x()) + ',' + str(room_y()))) 
        object_set_visibility(savegame_string('Collected Pixies', str(room_x()) + ',' + str(room_y())),False)

    # Iterate through buttons that have been pressed
    button_list = savegame_list_keys(str(room_x())+','+str(room_y())+' Buttons')
    for identifier in button_list:
        #Pres down buttons
        sprite_greyswitch_set_state(identifier,True)
        #Open doors
        sprite_door_open(identifier,True)

    # Iterate through items and removed ones picked up, and load their images and ones not picked.
    item_list = sprite_list_identifiers('Item',True)
    for identifier in item_list:
        if savegame_string('Collected Items',str(room_x())+','+str(room_y())+' '+identifier) is not False:
            sprite_delete('Item',identifier)
        else:
            sprite_item_load_image(identifier)

    if event=="After Death":
        # If the player just entered the twilight zone, restore the position to return to after death and fade in screen
        if savegame_value('General', 'Enter Twilight') == 1:
            savegame_set_key('General', 'X Room', savegame_value('General', 'Return X Room'))
            savegame_set_key('General', 'Y Room', savegame_value('General', 'Return Y Room'))
            savegame_set_key('General', 'X Position', savegame_value('General', 'Return X Position'))
            savegame_set_key('General', 'Y Position', savegame_value('General', 'Return Y Position'))
            savegame_delete_key('General','Return X Room')
            savegame_delete_key('General','Return Y Room')
            savegame_delete_key('General','Return X Position')
            savegame_delete_key('General','Return Y Position')
            savegame_delete_key('General','Enter Twilight')
            savegame_set_key('General', 'Twilight Entries', savegame_value('General', 'Twilight Entries') + 1)
            savegame_set_key('General', 'Player Is In Twilight', 1)
            overlay_fade(5)
            twilight_enter(savegame_value('General', 'Twilight Time'))

        # If the player just exited the twilight zone, fade in screen
        elif savegame_value('General', 'Player Is In Twilight') == 1:
            savegame_delete_key('General','Player Is In Twilight')
            overlay_set_transparency(0)
            overlay_fade(3)

    # Block the map in the twilight zone. This needs to be placed after the "afer death" section above since that handles
    # if you were actually leaving the twilight at this room_loaded.
    if savegame_value('General', 'Player Is In Twilight') == 1:
        map_block()

################################################## Leaving a room ##################################################
def room_leaving(side):
    # Transport the player to other rooms. Do also try to create a secret passage marker here.
    # The game will take care of only adding secret passages where there are walls.
    if side=='Top':
        map_verticalpath_create(room_x(),room_y()-1,0)
        room_set(room_x(), room_y()-1)
    elif side=='Right':
        map_horizontalpath_create(room_x(),room_y(),0)
        room_set(room_x()+1, room_y())
    elif side=='Bottom':
        map_verticalpath_create(room_x(),room_y(),0)
        room_set(room_x(), room_y()+1)
    elif side=='Left':
        map_horizontalpath_create(room_x()-1,room_y(),0)
        room_set(room_x()-1, room_y())

################################################## The Twilight Zone ##################################################
def sprite_warpsymbol_activated():
    #Exit the twilight zone. The room script must determine where in the map the player should appear.
    overlay_fade(-2)
    music_delete('Everybody Hates Fast Travel/Layer 0')
    savegame_set_key('General', 'X Position', player_x_tile())
    savegame_set_key('General', 'Y Position', player_y_tile())
    savegame_set_key('General', 'Direction', player_direction())
    game_trigger_death('Exit Twilight',128)

def twilight_entrypoint(destination_x,destination_y):
    if not dialog_speakonce('Twilight', 'Introduction', twilight_decision, destination_x, destination_y):
        if resource_count('Dimension') == 0:
            dialog_show('Twilight', 'No Crystals', None)
        else:
            dialog_show('Twilight', 'Enter', twilight_decision, destination_x, destination_y)

def twilight_decision(group, item, options, destination_x, destination_y):
    if options[0] == 0:
        #resource_subtract('Dimension',1)
        #inventory_refresh(True)
        savegame_set_key('General', 'Enter Twilight', 1)
        savegame_set_key('General', 'Return X Room', savegame_value('General', 'X Room'))
        savegame_set_key('General', 'Return Y Room', savegame_value('General', 'Y Room'))
        savegame_set_key('General', 'Return X Position', savegame_value('General', 'X Position'))
        savegame_set_key('General', 'Return Y Position', savegame_value('General', 'Y Position'))
        savegame_set_key('General', 'X Room', destination_x)
        savegame_set_key('General', 'Y Room', destination_y)
        savegame_set_key('General', 'X Position', player_x_tile())
        savegame_set_key('General', 'Y Position', player_y_tile())
        savegame_set_key('General', 'Direction', player_direction())
        if savegame_value('Inventory', 'Red Protective Orb (Misc)') >= 1:
            savegame_set_key('General', 'Twilight Time', 800)
        elif savegame_value('Inventory', 'Blue Protective Orb (Misc)') >= 1:
            savegame_set_key('General', 'Twilight Time', 700)
        else:
            savegame_set_key('General', 'Twilight Time', 600)
        music_delete_all()
        overlay_fade(-1)
        game_trigger_death('Enter Twilight',255)

def death(deathtype):
    if deathtype == "Twilight Timeout" and savegame_value('General', 'Show Twilight Fail Dialog') == 1 and savegame_value('General', 'Twilight Entries') == 1:
        dialog_show('Twilight', 'First Fail', None)

def twilight_unplanned_entry(destination_x, destination_y, twilighttime):
        savegame_set_key('General', 'Enter Twilight', 1)
        savegame_set_key('General', 'Return X Room', savegame_value('General', 'X Room'))
        savegame_set_key('General', 'Return Y Room', savegame_value('General', 'Y Room'))
        savegame_set_key('General', 'Return X Position', savegame_value('General', 'X Position'))
        savegame_set_key('General', 'Return Y Position', savegame_value('General', 'Y Position'))
        savegame_set_key('General', 'X Room', destination_x)
        savegame_set_key('General', 'Y Room', destination_y)
        savegame_set_key('General', 'X Position', player_x_tile())
        savegame_set_key('General', 'Y Position', player_y_tile())
        savegame_set_key('General', 'Direction', player_direction())
        savegame_set_key('General', 'Twilight Time', twilighttime)
        music_delete_all()
        overlay_fade(-1)
        game_trigger_death('Enter Twilight',255)

################################################## Touching an item ##################################################
def sprite_item_touched(identifier):
    # Pick up the item
    sprite_item_pickup(identifier)

    # Delete the room type
    map_roomtype_delete(room_x(),room_y())

    # Store that this item was picked up, and refresh inventory
    savegame_set_key('Collected Items',str(room_x())+','+str(room_y())+' '+identifier,"Collected")
    savegame_set_key('Inventory',identifier,savegame_value('Inventory',identifier)+1)
    inventory_refresh(True)

    # Store the player position so the player will start from here after death
    savegame_set_key('General','X Room',room_x())
    savegame_set_key('General','Y Room',room_y())
    savegame_set_key('General','X Position',player_x_tile())
    savegame_set_key('General','Y Position',player_y_tile())
    savegame_set_key('General','Direction',player_direction())

################################################## Pressing a switch ##################################################
def sprite_greyswitch_pressed(identifier,variant):
    try:
        room_script.sprite_greyswitch_override()
    except:
        if not sprite_greyswitch_state(identifier):
            # Remove the map icon in this room
            map_roomtype_delete(room_x(),room_y())

            # Store that the button have been pressed
            savegame_set_key(str(room_x())+','+str(room_y())+' Buttons',identifier,'Pressed')

            # Store the player position so the player will start from here after death
            savegame_set_key('General','X Room',str(room_x()))
            savegame_set_key('General','Y Room',str(room_y()))
            savegame_set_key('General','X Position',str(player_x_tile()))
            savegame_set_key('General','Y Position',str(player_y_tile()))

            # Store the player direction. If the switches is located on a wall, the player direction must face
            # the wall so the player doesn't fall down if starting from this position after death.
            if variant==0 or variant==2: savegame_set_key('General','Direction',player_direction())
            if variant==1: savegame_set_key('General','Direction',1)
            if variant==3: savegame_set_key('General','Direction',-1)

            # Press down button
            sprite_greyswitch_set_state(identifier,True)

            # Open all doors with the same identifier
            sprite_door_open(identifier,False)

            # Clear quest targets
            savegame_delete_key('Targets','Main Quest '+str(room_x())+','+str(room_y()))
            map_target_refresh()

            # Call a function in the room script to handle anything more this button might need to do
            try:
                room_script.greyswitch_pressed(identifier,variant)
            except AttributeError:
                pass

################################################## Earthquake Once ##################################################
def effect_earthquake_once(identifier,time):
    if savegame_string('Earthquakes', identifier) is False:
        savegame_set_key('Earthquakes', identifier, 1)
        effect_earthquake(time)
        return True
    else:
        return False

################################################## Fairy ##################################################
def fairies_create_dora():
    fairy_create('Dora', 2, 30, 95, 30)

def fairies_create_cilia():
    fairy_create('Cilia', 6, 60, 95, 60)

def fairies_create_niles():
    fairy_create('Niles', 0, 30, 95, 30)

def fairies_create_rob():
    fairy_create('Rob', 5, 30, 95, 30)

def fairies_create_ethan():
    fairy_create('Ethan', 12, 30, 95, 30)

def fairies_create_robofairy():
    fairy_create('Robo Fairy', 12, 90, 95, 2)

################################################## Figure ##################################################
def figure_abort():
    dialog_show('Figure', 'Abort', figure_leave)

def figure_leave(group, item, options):
    if options[0] == 0:
        savegame_set_key('General', 'X Room', 38)
        savegame_set_key('General', 'Y Room', 31)
        savegame_set_key('General', 'X Position', 15)
        savegame_set_key('General', 'Y Position', 4)
        music_delete_all()
        game_trigger_death('Teleport',128)

def minifigure_abort():
    dialog_show('Figure', 'Abort Mini', minifigure_leave)

def minifigure_leave(group, item, options):
    if options[0] == 0:
        savegame_set_key('General', 'X Room', 39)
        savegame_set_key('General', 'Y Room', 31)
        savegame_set_key('General', 'X Position', 11)
        savegame_set_key('General', 'Y Position', 11)
        music_delete_all()
        game_trigger_death('Teleport',128)

def tinyfigure_abort():
    dialog_show('Figure', 'Abort Tiny', tinyfigure_leave)

def tinyfigure_leave(group, item, options):
    if options[0] == 0:
        savegame_set_key('General', 'X Room', 24)
        savegame_set_key('General', 'Y Room', 35)
        savegame_set_key('General', 'X Position', 15)
        savegame_set_key('General', 'Y Position', 10)
        music_delete_all()
        game_trigger_death('Teleport',128)

################################################## Debug ##################################################
debug_lastkey = None
def debug_dejitter():
	from time import clock
	global debug_lastkey
	c = clock()
	#prevent room changes occurring more than once per 250ms
	if debug_lastkey and c - debug_lastkey < 0.25:
		return False
	debug_lastkey = c
	return True
	
def debug_error_handler(func):
	def wrapped_func(*args, **kwargs):
		try:
			return func(*args, **kwargs)
		except:
			#DISABLED FOR PUBLIC RELEASE (besides, writing to c:\ with Windows' UAC on probably would fail anyway)
			# import sys #, traceback
			# et, ei, tb = sys.exc_info()
			# log = open("c:/log.txt","a")
			
			# log.write("{}\t{}\t{}\n".format(repr(et), repr(ei), repr(tb)))
			# #traceback not available in embedded python
			# #traceback.print_exception(et, ei, tb, None, log)
			# log.close()
			raise
	return wrapped_func
			

def debug_teleport_to(x,y):
	if room_exists(x,y):
		savegame_set_key('General', 'X Room', x)
		savegame_set_key('General', 'Y Room', y)
		# Uncomment to set position every time you teleport
		# savegame_set_key('General', 'X Position', 15)
		# savegame_set_key('General', 'Y Position', 10)
		music_delete_all()
		game_trigger_death('Teleport',32)
	else:
		dialog_show('Debug Tour', 'ErrorTeleporting', None)

@debug_error_handler
def debug_tour_move(dir=None):
	x, y = debug_tour_get()
	lastmove = savegame_value('General', 'Tour Last Move')
	#check we have a valid direction to work with
	if not dir in (0,1,2,3):
		if not lastmove in (0,1,2,3): return
		dir = lastmove

	savegame_set_key('General', 'Tour Last Move', dir)
		
	#dir is 0:up, 1:right, 2:down, 3:left
	dx = (0,1,0,-1)[dir]
	dy = (-1,0,1,0)[dir]
	
	for i in xrange(5): #Continue moving in this direction until a valid room is reached, or stop after 5 moves to prevent infinite loops
		x += dx
		y += dy
		#wrap around the map if the edge is reached
		if x < 0: x = 47; y -= 1
		if x > 47: x = 0; y += 1
		if y < 0: y = 42
		if y > 42: y = 0
		
		# if room_exists(x,y):
		debug_tour_set(x,y)
		debug_teleport_to(x,y)
		return
		
	
def debug_tour_get():
	return (
		savegame_value('General', 'X Tour') or room_x(),
		savegame_value('General', 'Y Tour') or room_y(),
	)
	
def debug_tour_set(x,y):
	savegame_set_key('General', 'X Tour', x)
	savegame_set_key('General', 'Y Tour', y)
	
def debug_tour_menu():
	
	# The following is kind of awkward as each step needs to refer to the step 
	# after it, so they're actually defined in reverse order
	
	# Step 3: Process the player's choice
	@debug_error_handler
	def menu_action(group, last_item, options, in_tour_room):
		# in_tour_room == False actions: Return to tour\Move tour here\Tour up\Tour right\Tour down\Tour left\More...\Do nothing
		# in_tour_room == True actions: Tour up\Tour right\Tour down\Tour left\More...\Do nothing
		action_idx = options[0] + (2 if in_tour_room else 0)
		
		if action_idx == 0: #Return to tour
			debug_teleport_to(*debug_tour_get())
		elif action_idx == 1: #Move tour here & redisplay movement menu
			debug_tour_set(room_x(), room_y())
			dialog_show('Debug Tour', 'InTourRoom ' + tour_xy, menu_action, True)
		elif action_idx in (2,3,4,5): #Move with tour
			debug_tour_move(action_idx - 2)
		elif action_idx == 6: #More...
			debug_menu_more()
		else: #Do nothing
			pass
	
	
	tour_xy = "{},{}".format(*debug_tour_get())
	pos_xy = "{},{}".format(room_x(), room_y())
	
	if tour_xy == pos_xy: #If player is in the tour room
		# Step 1/2: Show current/tour location & options
		dialog_show('Debug Tour', 'InTourRoom ' + tour_xy, menu_action, True)
	else:
		# Step 2: Show tour location & options
		@debug_error_handler
		def next(group, last_item, options):
			dialog_show('Debug Tour', 'FarTourRoom ' + tour_xy, menu_action, False)
		# Step 1: Show current location
		dialog_show('Debug Tour', 'AtRoom ' + pos_xy, next)
	
def debug_menu_more():
	@debug_error_handler
	def menu_action(group, last_item, options):
		if options[0] == 0: # Save game
			savegame_save()
		elif options[0] == 1: # Enable powers
			savegame_set_key('Powers', 'Character Transform', 1)
			savegame_set_key('Powers', 'Inventory', 1)
			savegame_set_key('Inventory', 'Micro Mapper (Useable)', 1)
			savegame_set_key('Inventory', 'Mapper (Useable)', 1)
			inventory_refresh(True)
			map_unblock()
		elif options[0] == 2: # Teleport
			debug_menu_teleport()
		elif options[0] == 3: # Secret levels
			debug_menu_secret_levels()
		else: # Do nothing
			pass
			
	dialog_show('Debug Tour', 'DebugMore', menu_action)

def debug_menu_secret_levels():
	secret_levels = (
		('Juni and The Puzzle Piece', 'Red'),
		('HUMLab Murder Mystery', 'Green'),
		('Sync Transform', 'Green'),
		('Neon Fall', 'Blue'),
		('Chowdren', 'Green'),
		('A Toast', 'Blue'),
	)
	@debug_error_handler
	def menu_action(group, last_item, options):
		if 0 <= options[0] <= len(secret_levels): # Save game
			game_load(*secret_levels[options[0]])
		else: # Do nothing
			pass
	
	dialog_show('Debug Tour', 'DebugSecretLevels', menu_action)


def debug_menu_teleport():
	def run():
		dialog_show('Debug Teleport', 'DebugTPX', select_x_part1, (0,0))
		
	@debug_error_handler
	def select_x_part1(group, last_item, options, coord):
		i = options[0]
		dialog_show('Debug Teleport', 'DebugTPX' + str(i), select_x_part2, (coord[0] + i*6, coord[1]))
	@debug_error_handler
	def select_x_part2(group, last_item, options, coord):
		i = options[0]
		if i == 6: return #Cancel
		dialog_show('Debug Teleport', 'DebugTPY', select_y_part1, (coord[0] + i, coord[1]))
	
	@debug_error_handler
	def select_y_part1(group, last_item, options, coord):
		i = options[0]
		dialog_show('Debug Teleport', 'DebugTPY' + str(i), select_y_part2, (coord[0], coord[1] + i*6))
	@debug_error_handler
	def select_y_part2(group, last_item, options, coord):
		i = options[0]
		if i == 6 or coord[1] + i > 42: return #Cancel
		debug_teleport_to(coord[0], coord[1] + i)
	
	run()
	
@debug_error_handler
def debug_f9():
	if debug_dejitter(): debug_tour_menu()

@debug_error_handler	
def debug_f11():
	if debug_dejitter(): debug_tour_move()

################################################## Using a triggered function object ##################################################
def function_keypress(identifier):
    # Store the player position so the player will start from here after death
    if not twilight_is_active():
        savegame_set_key('General','X Room',room_x())
        savegame_set_key('General','Y Room',room_y())
        savegame_set_key('General','X Position',player_x_tile())
        savegame_set_key('General','Y Position',player_y_tile())
        savegame_set_key('General','Direction',player_direction())

################################################## Enlightenment ##################################################
# These quests will be unlocked by enlightenment (room_x, room_y, required enlightenment level)
ENLIGHTENMENT_UNLOCKS = {
    'Dora': [[14, 14, 4]],
    'Cilia': [[2, 12, 3], [30, 22, 4], [45, 15, 3]]
}

def enlightenment_enlighten(fairy, identifier):
    savegame_set_key(fairy+"'s Enlightenment", identifier, 'Learnt')
    for key in ENLIGHTENMENT_UNLOCKS[fairy]:
        if enlightenment_level(fairy) >= key[2]:
            map_roomtype_unlock(key[0], key[1])

def enlightenment_level(fairy):
    enlightenments_found = 0
    for key in savegame_list_keys(fairy+"'s Enlightenment"):
        if savegame_string(fairy+"'s Enlightenment",key)=="Learnt":
            enlightenments_found = enlightenments_found + 1
    return enlightenments_found

################################################## Close Quest ##################################################
def quest_close():
    savegame_delete_key('General','Active Quest')
    savegame_delete_pattern('Targets','Side Quest*','*')
    map_target_refresh()

################################################## Resources ##################################################

def resource_count(resource_type):
        resource_total = 0
        for item in savegame_list_keys('Inventory'):
            if item[0-(len(resource_type)+2):] == '(' + resource_type  + ')':
                resource_total += savegame_value('Inventory',item)
        return resource_total

def resource_subtract(resource_type,resource_total):
    for item in savegame_list_keys('Inventory'):
        if item[0-(len(resource_type)+2):] == '(' + resource_type  + ')':
            resources_to_subtract = min(savegame_value('Inventory',item),resource_total)
            savegame_set_key('Inventory', item, savegame_value('Inventory',item) - resources_to_subtract)
            resource_total -= resources_to_subtract

################################################## Simple Choice ##################################################
def simple_choice_npc(group):
    if savegame_string('Selected Fairies',group) is False:
        dialog_show(group,'Opening',simple_choice)
        return True
    else:
        dialog_show(group+': '+savegame_string('Selected Fairies',group),'Talk Again',None)
        return False

def simple_choice(group, last_item, options):
    # Dora
    if options[0] == 0:
        savegame_set_key('Selected Fairies',group,'Dora')
        dialog_show(group+': Dora','Response',None)
    # Cilia
    else:
        savegame_set_key('Selected Fairies',group,'Cilia')
        dialog_show(group+': Cilia','Response',None)

################################################## Pick Up Pixie ##################################################

def pixie_collect(identifier):
    savegame_set_key('Inventory',identifier + ' (Pixie)',1)
    savegame_set_key('Collected Pixies', str(room_x()) + ',' + str(room_y()), identifier)
    inventory_refresh(True)
    map_roomtype_delete(room_x(),room_y())
    if savegame_value('Map','27,7') is not False:
        map_roomtype_set(27, 7, 7)
    dialog_show('Collect Pixie',identifier,pixie_story, identifier)

def pixie_story(group, item, options, identifier):
    sprite_delete('Function',identifier)
    sprite_delete('Simple Animation',identifier)
    object_set_visibility(identifier,False)
    dialog_show('Pixie Story', 'Story '+str(len(savegame_list_keys('Collected Pixies'))-1), None)
    

################################################## Fairyless Fetch Quests ##################################################
# Data about individual quests
FAIRYLESS_FETCHQUESTS = {
    'Johann and Door': {
        'Quest Coordinate': [7,9],
        'Item': 'Candlestick (Misc)',
        'Item Coordinates': [[2,9],[3,11]],
        'Press Button': 'Door'
    },
    "Susanna's Gems": {
        'Quest Coordinate': [15,9],
        'Item': 'Green Gemstone (Misc)',
        'Item Coordinates': [[9,14],[12,9]],
        'Press Button': 'Door'
    },
    'Blood Melon': {
        'Quest Coordinate': [17,4],
        'Item': 'Blood Melon (Misc)',
        'Item Coordinates': [[17,1],[19,0],[19,1]],
    }
}

# Trigger this function to start a Fairyless Fetch Quest
def fairyless_fetchquest_npc(quest):
    global FAIRYLESS_FETCHQUESTS
    questdata=FAIRYLESS_FETCHQUESTS[quest]
    # If the quest is already complete,
    if savegame_string('Quest Status',quest) == 'Completed':
        dialog_show(quest,"Already Complete",None)
    # The quest is or was once accepted or Declined, and now the player have enough items
    elif savegame_value('Inventory',questdata['Item']) >= len(questdata['Item Coordinates']) and savegame_string('Quest Status',quest) is not False:
        fairyless_fetchquest_complete(quest)
    # The quest is already active
    elif savegame_string('General','Active Quest') == quest: 
        dialog_show(quest,"Already Active",None)
    # The quest was once accepted but is now inactive
    elif savegame_string('Quest Status',quest) == 'Accepted':
        dialog_show(quest,'Player Reactivate Quest',fairyless_fetchquest_begin,True)
    # The quest was once Declined
    elif savegame_string('Quest Status',quest) == 'Declined':
        dialog_show(quest,'Reconsider',fairyless_fetchquest_accept)
    # The first time you talk to this character
    else:
        dialog_show(quest,'Opening',fairyless_fetchquest_accept)

# If the items are already found, autocomplete the quest now. Otherwise, ask the player if the quest should be accepted.
def fairyless_fetchquest_accept(quest,last_key,options):
    global FAIRYLESS_FETCHQUESTS
    questdata=FAIRYLESS_FETCHQUESTS[quest]
    # The player holds the required items to complete the quest, so complete it instantly
    if savegame_value('Inventory',questdata['Item']) >= len(questdata['Item Coordinates']):
        fairyless_fetchquest_complete_actions(quest)
        dialog_show(quest,"Autocomplete",None)
    # The player is missing items and must go on a quest to find them
    else:
        dialog_show(quest,"Player Accept Quest",fairyless_fetchquest_begin,False)

# If the player responded Yes to accepting the quest, make it the active quest and place the targets.
def fairyless_fetchquest_begin(quest,last_key,options,skip_dialog):
    global FAIRYLESS_FETCHQUESTS
    questdata=FAIRYLESS_FETCHQUESTS[quest]
    if options[0] != 0:
        if savegame_string('Quest Status',quest) is False:
            savegame_set_key('Quest Status',quest,'Declined')
        if skip_dialog is False:
            dialog_show(quest,"Decline",None)
    else:
        quest_close()
        savegame_set_key('General','Active Quest',quest)
        savegame_set_key('Quest Status',quest,'Accepted')
        for item_coordinate in questdata['Item Coordinates']:
            if not iszero(savegame_value('Map',str(item_coordinate[0])+","+str(item_coordinate[1])+" Type")):
                map_reveal(item_coordinate[0], item_coordinate[1],True)
                map_roomtype_unlock(item_coordinate[0], item_coordinate[1])
                map_roomtype_reveal(item_coordinate[0], item_coordinate[1])
                savegame_set_key(
                    'Targets',
                    'Side Quest '+str(item_coordinate[0])+','+str(item_coordinate[1]),
                    str(item_coordinate[0])+','+str(item_coordinate[1])+',4,'+quest+',Target Description 0'
                )
        map_target_refresh()
        if skip_dialog is False:
            dialog_show(quest,"Accept",None)

# Complete the quest when the player have enough items
def fairyless_fetchquest_complete(quest):
    fairyless_fetchquest_complete_actions(quest)
    dialog_show(quest,"Complete",None)

# Things that needs to be done to complete a quest
def fairyless_fetchquest_complete_actions(quest):
    global FAIRYLESS_FETCHQUESTS
    questdata=FAIRYLESS_FETCHQUESTS[quest]
    savegame_set_key(
       'Inventory',questdata['Item'],
        savegame_value('Inventory',questdata['Item'])-len(questdata['Item Coordinates'])
    )
    if 'Rewards' in questdata:
        for reward in questdata['Rewards']:
            savegame_set_key('Inventory',reward,savegame_value('Inventory',reward)+1)
    inventory_refresh(True)
    if 'Press Button' in questdata:
        savegame_set_key(str(room_x())+','+str(room_y())+' Buttons',questdata['Press Button'],'Pressed')
        sprite_greyswitch_set_state(questdata['Press Button'],True)
        sprite_door_open(questdata['Press Button'],False)
    map_roomtype_delete(room_x(),room_y())
    savegame_set_key('Quest Status',quest,'Completed')
    # Close the quest if this is the active quest
    if savegame_string('General','Active Quest') == quest:
        quest_close()

# Trigger this function when you pick up an item in a Fetch quest
def fairyless_fetchquest_item(quest):
    global FAIRYLESS_FETCHQUESTS
    questdata=FAIRYLESS_FETCHQUESTS[quest]
    if savegame_string('General','Active Quest') == quest:
        savegame_delete_key('Targets','Side Quest '+str(room_x())+','+str(room_y()))
        map_target_refresh()

        if savegame_value('Inventory',questdata['Item']) >= len(questdata['Item Coordinates']):
            savegame_delete_pattern('Targets','Side Quest*','*')
            savegame_set_key(
                'Targets',
                'Side Quest Return',
                str(questdata['Quest Coordinate'][0])+','+str(questdata['Quest Coordinate'][1])+',4,'+quest+',Enough Items 0'
            )
            map_target_refresh()
            dialog_show(quest,'Enough Items',None)

################################################## Fetch Quests ##################################################
# Data about individual quests
FETCHQUESTS = {
    "Juni's Umbrella": {
        'Quest Coordinate': [24,22],
        'Item': 'Umbrella (Misc)',
        'Item Coordinates': [[25,22]],
        'Rewards': ['The Hook (Glyph)']
    },
    "The Basket": {
        'Quest Coordinate': [9,23],
        'Item': 'Basket (Misc)',
        'Item Coordinates': [[9,22]]
    },
    "The Harddisk": {
        'Quest Coordinate': [12,24],
        'Item': 'Red Gemstone (Misc)',
        'Item Coordinates': [[13,20],[13,28]],
        'Rewards': ['Harddisk (Artifact)']
    },
    "Professor Flip-Flop": {
        'Quest Coordinate': [33,12],
        'Item': 'Wheel (Utopioca)',
        'Item Coordinates': [[33,11]],
        'Rewards': ['Wheel (Utopioca)']
    },
    "Chico's Miracle": {
        'Quest Coordinate': [39,10],
        'Item': 'Ring (Misc)',
        'Item Coordinates': [[40,9]]
    },
    "Ionel's Museum": {
        'Quest Coordinate': [45,15],
        'Item': 'Skull (Misc)',
        'Item Coordinates': [[45,16],[47,9],[42,10]],
        'Rewards': ['Aditi (Stone)']
    },
    "Moonshine": {
        'Quest Coordinate': [2,12],
        'Item': 'Soul Crystal (Forbidden Artifact)',
        'Item Coordinates': [[8,11],[4,16]],
        'Rewards': ['Moon Flower (Flowers)']
    },
    "Double Armageddon": {
        'Quest Coordinate': [1,16],
        'Item': 'Red Protective Orb (Misc)',
        'Item Coordinates': [[3,18],[3,20],[5,16]],
        'Rewards': ['Blood Flower (Flowers)']
    },
    "Johann's Deception": {
        'Quest Coordinate': [12,21],
        'Item': 'Golden Bird (Misc)',
        'Item Coordinates': [[12,20]],
        'Rewards': ['Fake Artifact (Junk)']
    },
    "Lauritz' Redemption": {
        'Quest Coordinate': [28,15],
        'Item': 'Stick (Junk)',
        'Item Coordinates': [[28,12]],
        'Rewards': ['Poke (Artifact)']
    },
    "The Bolt of Awakyinsomawan": {
        'Quest Coordinate': [36,18],
        'Item': 'The Bolt of Awakyinsomawan (Misc)',
        'Item Coordinates': [[32,18]],
        'Rewards': ['Arrow (Glyph)']
    },
    "The Horse God": {
        'Quest Coordinate': [30,19],
        'Item': 'Northern Horse God (Misc)',
        'Item Coordinates': [[33,19]]
    },
    "Aoi's Egg": {
        'Quest Coordinate': [5,7],
        'Item': "Aoi's Egg (Misc)",
        'Item Coordinates': [[5,6]]
    },
    'Herr Igitt': {
        'Quest Coordinate': [30,7],
        'Item': "Herr Igitt (Misc)",
        'Item Coordinates': [[30,3],[32,8]],
        'Rewards': ['Herr Igitt (Misc)','Herr Igitt (Misc)']
    },
    'Fiber Optic': {
        'Quest Coordinate': [36,26],
        'Item': "Who Knows What (Misc)",
        'Item Coordinates': [[41,26],[40,28],[42,28]],
        'Rewards': ['Ray Gun (Forbidden Artifact)']
    }
}

# Trigger this function to start a Fetch quest
def fetchquest_npc(quest):
    global FETCHQUESTS
    questdata=FETCHQUESTS[quest]
    # If the quest is already complete
    if savegame_string('Quest Status',quest) == 'Completed':
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),"Already Complete",None)
    # The quest is or was once accepted or Declined, and now the player have enough items
    elif savegame_string('Quest Status',quest) is not False and savegame_value('Inventory',questdata['Item']) >= len(questdata['Item Coordinates']):        
        fetchquest_complete(quest)
    # The quest is already active
    elif savegame_string('General','Active Quest') == quest: 
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Already Active',None)
    # The quest was once accepted but is now inactive
    elif savegame_string('Quest Status',quest) == 'Accepted':
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Player Reactivate Quest',fetchquest_begin,quest,True)
    # The quest was once Declined
    elif savegame_string('Quest Status',quest) == 'Declined':
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Reconsider',fetchquest_accept,quest)
    # The first time you talk to this character
    else:
        dialog_show(quest,'Opening',fetchquest_select_fairy)

# Store which fairy the player selected.
def fetchquest_select_fairy(quest,last_key,options):
    # A character has been pre-selected by a room script for this quest.
    if savegame_string('Selected Fairies',quest) is not False:
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest), "Response", fetchquest_accept, quest)
    # Dora
    elif (options[0] == 0):
        savegame_set_key('Selected Fairies',quest,'Dora')
        dialog_show(quest+": Dora","Response",fetchquest_accept,quest)
    # Cilia
    else:
        savegame_set_key('Selected Fairies',quest,'Cilia')
        dialog_show(quest+": Cilia","Response",fetchquest_accept,quest)

# If the items are already found, autocomplete the quest now. Otherwise, ask the player if the quest should be accepted.
def fetchquest_accept(last_group,last_key,options,quest):
    global FETCHQUESTS
    questdata=FETCHQUESTS[quest]
    #The player holds the required items to complete the quest, so complete it instantly
    if savegame_value('Inventory',questdata['Item']) >= len(questdata['Item Coordinates']):
        fetchquest_complete_actions(quest)
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),"Autocomplete",None)
    #The player is missing items and must go on a quest to find them
    else:
        dialog_show(quest,"Player Accept Quest",fetchquest_begin,quest,False)

# If the player responded Yes to accepting the quest, make it the active quest and place the targets.
def fetchquest_begin(last_group,last_key,options,quest,skip_dialog):
    global FETCHQUESTS
    questdata=FETCHQUESTS[quest]
    if options[0] != 0:
        if savegame_string('Quest Status',quest) is False:
            savegame_set_key('Quest Status',quest,'Declined')
        if skip_dialog is False:
            dialog_show(quest+": "+savegame_string('Selected Fairies',quest),"Decline",None)
    else:
        quest_close()
        savegame_set_key('General','Active Quest',quest)
        savegame_set_key('Quest Status',quest,'Accepted')
        for item_coordinate in questdata['Item Coordinates']:
            if not iszero (savegame_value('Map',str(item_coordinate[0])+","+str(item_coordinate[1])+" Type")):
                map_reveal(item_coordinate[0], item_coordinate[1],True)
                map_roomtype_reveal(item_coordinate[0], item_coordinate[1])
                savegame_set_key(
                    'Targets',
                    'Side Quest '+str(item_coordinate[0])+','+str(item_coordinate[1]),
                    str(item_coordinate[0])+','+str(item_coordinate[1])+',4,'+quest+": "+savegame_string('Selected Fairies',quest)+',Target Description 0'
                )
        map_target_refresh()
        if skip_dialog is False:
            dialog_show(quest+": "+savegame_string('Selected Fairies',quest),"Accept",None)

# Complete the quest when the player have enough items
def fetchquest_complete(quest):
    fetchquest_complete_actions(quest)
    dialog_show(quest+": "+savegame_string('Selected Fairies',quest),"Complete",None)

# Things that needs to be done to complete a quest
def fetchquest_complete_actions(quest):
    global FETCHQUESTS
    questdata=FETCHQUESTS[quest]
    savegame_set_key(
       'Inventory',questdata['Item'],
        savegame_value('Inventory',questdata['Item'])-len(questdata['Item Coordinates'])
    )
    if 'Rewards' in questdata:
        for reward in questdata['Rewards']:
            savegame_set_key('Inventory',reward,savegame_value('Inventory',reward)+1)
    inventory_refresh(True)
    if 'Press Button' in questdata:
        savegame_set_key(str(room_x())+','+str(room_y())+' Buttons',questdata['Press Button'],'Pressed')
        sprite_greyswitch_set_state(questdata['Press Button'],True)
        sprite_door_open(questdata['Press Button'],False)
    map_roomtype_delete(room_x(),room_y())
    savegame_set_key('Quest Status',quest,'Completed')
    # Close the quest if this is the active one
    if savegame_string('General','Active Quest') == quest:
        quest_close()

# Trigger this function when you pick up an item in a Fetch quest
def fetchquest_item(quest):
    global FETCHQUESTS
    questdata=FETCHQUESTS[quest]
    if savegame_string('General','Active Quest') == quest:
        savegame_delete_key('Targets','Side Quest '+str(room_x())+','+str(room_y()))
        map_target_refresh()
        if savegame_value('Inventory',questdata['Item']) >= len(questdata['Item Coordinates']):
            savegame_delete_pattern('Targets','Side Quest*','*')
            savegame_set_key(
                'Targets',
                'Side Quest Return',
                str(questdata['Quest Coordinate'][0])+','+str(questdata['Quest Coordinate'][1])+',4,'+quest+": "+savegame_string('Selected Fairies',quest)+',Enough Items 0'
            )
            map_target_refresh()
            dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Enough Items',None)

################################################## Fairyless Delivery Quests ##################################################
# Data about individual quests
FAIRYLESS_DELIVERYQUESTS = {
    'Hannah First Clue': {
        'Sender Coordinate': [14,11],
        'Receiver Coordinate': [15,14]
    },
    "Locating Hannah's Family": {
        'Sender Coordinate': [15,14],
        'Receiver Coordinate': [21,19]
    },
    "Finding Hannah": {
        'Sender Coordinate': [21,19],
        'Receiver Coordinate': [11,16]
    },
    "Introducing Spectral Diamond": {
        'Sender Coordinate': [20,20],
        'Upfront Rewards': ['Treasure Map (Misc)'],
        'Receiver Coordinate': [26,26]
    },
    "Spectral Diamond More Clues": {
        'Sender Coordinate': [26,26],
        'Receiver Coordinate': [29,20]
    },
    "Finding Spectral Diamond": {
        'Sender Coordinate': [29,20],
        'Receiver Coordinate': [39,18],
        'Rewards': ['Spectral Diamond (Misc)']
    },
    'Bluestone': {
        'Sender Coordinate': [4,28],
        'Receiver Coordinate': [4,27],
        'Rewards': ['Bluestone (Stone)']
    }
}

# Trigger this function to start a fairyless delivery quest
def fairyless_deliveryquest_sender(quest):
    # If the quest is already complete
    if savegame_string('Quest Status',quest) == 'Completed':
        dialog_show(quest,'Sender Talk Again',None)
    # If the quest is already active
    elif savegame_string('General','Active Quest') == quest:
        dialog_show(quest,'Sender Already Active',None)
    # If the quest is started since before but not active
    elif savegame_string('Quest Status',quest) == 'Accepted':
        dialog_show(quest,'Player Reactivate Quest',fairyless_deliveryquest_begin,True)
    # If the quest have previously been declined
    elif savegame_string('Quest Status',quest) == 'Declined':
        dialog_show(quest,'Reconsider',fairyless_deliveryquest_accept)
    # If the quest have never been accepted
    else:
        dialog_show(quest,'Sender Opening',fairyless_deliveryquest_accept)

#Ask if the player will accept the quest.
def fairyless_deliveryquest_accept(quest,last_key,options):
    dialog_show(quest,"Player Accept Quest",fairyless_deliveryquest_begin,False)

# If the player responded Yes to accepting the quest, make it the active quest and place the target. Give the player the delivery item.
def fairyless_deliveryquest_begin(quest,last_key,options,reactivate):
    global FAIRYLESS_DELIVERYQUESTS
    questdata=FAIRYLESS_DELIVERYQUESTS[quest]
    if options[0] != 0:
        if savegame_string('Quest Status',quest) is False:
            savegame_set_key('Quest Status',quest,'Declined')
        if reactivate is False:
            dialog_show(quest,"Decline",None)
    else:
        savegame_set_key('General','Active Quest',quest)
        savegame_set_key('Quest Status',quest,'Accepted')
        savegame_delete_pattern('Targets','Side Quest*','*')
        savegame_set_key(
            'Targets',
            'Side Quest '+str(questdata['Sender Coordinate'][0])+','+str(questdata['Sender Coordinate'][1]),
            str(questdata['Receiver Coordinate'][0])+','+str(questdata['Receiver Coordinate'][1])+',4,'+quest+',Target Description 0'
        )
        map_target_refresh()
        map_reveal(questdata['Receiver Coordinate'][0], questdata['Receiver Coordinate'][1],True)
        map_roomtype_unlock(questdata['Receiver Coordinate'][0], questdata['Receiver Coordinate'][1])
        map_roomtype_reveal(questdata['Receiver Coordinate'][0], questdata['Receiver Coordinate'][1])
        if reactivate is False:
            if 'Item' in questdata:
                savegame_set_key('Inventory',questdata['Item'],savegame_value('Inventory',questdata['Item'])+1)
            if 'Upfront Rewards' in questdata:
                for reward in questdata['Upfront Rewards']:
                    savegame_set_key('Inventory',reward,savegame_value('Inventory',reward)+1)
            inventory_refresh(True)
            dialog_show(quest,"Accept",None)

# Trigger this function when the player talks to the reciever
def fairyless_deliveryquest_receiver(quest):
    # If the quest is already complete
    if savegame_string('Quest Status',quest) == 'Completed':
        dialog_show(quest,'Receiver Talk Again',None)
    # If the quest is active
    elif savegame_string('Quest Status',quest) == 'Accepted':
        fairyless_deliveryquest_complete(quest)
        dialog_show(quest,'Receiver Complete',None)
    # If the quest have never been accepted
    else:
        dialog_show(quest,'Receiver Opening',None)

def fairyless_deliveryquest_complete(quest):
    global FAIRYLESS_DELIVERYQUESTS
    questdata=FAIRYLESS_DELIVERYQUESTS[quest]
    if 'Item' in questdata:
        savegame_set_key(
            'Inventory',questdata['Item'],
            max(savegame_value('Inventory',questdata['Item'])-1,0)
        )
    if 'Rewards' in questdata:
        for reward in questdata['Rewards']:
            savegame_set_key('Inventory',reward,savegame_value('Inventory',reward)+1)
    inventory_refresh(True)
    if 'Press Button' in questdata:
        savegame_set_key(str(room_x())+','+str(room_y())+' Buttons',questdata['Press Button'],'Pressed')
        sprite_greyswitch_set_state(questdata['Press Button'],True)
        sprite_door_open(questdata['Press Button'],False)
    map_roomtype_delete(room_x(),room_y())
    map_roomtype_delete(questdata['Sender Coordinate'][0],questdata['Sender Coordinate'][1])
    savegame_set_key('Quest Status',quest,'Completed')
    # Close the quest if this is the open one
    if savegame_string('General','Active Quest') == quest:
        quest_close()

################################################## Delivery Quests ##################################################
# Data about individual quests
DELIVERYQUESTS = {
    "Knytt Warrior": {
        'Sender Coordinate': [31,2],
        'Receiver Coordinate': [33,2],
        'Rewards': ['Vidya (Stone)']
    },
    "Family and Debt": {
        'Sender Coordinate': [14,14],
        'Upfront Rewards': ['Battery (Artifact)'],
        'Item': 'Diamond (Misc)',
        'Receiver Coordinate': [17,16],
    },
    'Professor Julie': {
        'Sender Coordinate': [2,17],
        'Receiver Coordinate': [0,16]
    },
    'The Incident with The Metal Pineapples': {
        'Sender Coordinate': [46,17],
        'Receiver Coordinate': [46,18],
        'Press Button': 'Door'
    },
    'Avocado Transport': {
        'Sender Coordinate': [38,10],
        'Upfront Rewards': ['Silver Coin (Money)'],
        'Item': 'Avocado (Misc)',
        'Receiver Coordinate': [44,7]
    }
}

# Trigger this function to start a Delivery quest
def deliveryquest_sender(quest):
    # If the quest is already complete
    if savegame_string('Quest Status',quest) == 'Completed':
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Sender Talk Again',None)
    # If the quest is already active
    elif savegame_string('General','Active Quest') == quest:
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Sender Already Active',None)
    # If the quest is started since before but not active
    elif savegame_string('Quest Status',quest) == 'Accepted':
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Player Reactivate Quest',deliveryquest_begin,quest,True)
    # If the quest has previously been declined        
    elif savegame_string('Quest Status',quest) == 'Declined':
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Reconsider',deliveryquest_accept,quest)
    # If the quest has never been accepted
    else:
        dialog_show(quest,'Sender Opening',deliveryquest_respond)

# Store which fairy that was selected, and respond.
def deliveryquest_respond(quest,last_key,options):
    # A character have been pre-selected by a room script for this quest.
    if savegame_string('Selected Fairies',quest) is not False:
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest), "Sender Response", deliveryquest_accept, quest)
    # Dora
    elif options[0] == 0:
        savegame_set_key('Selected Fairies',quest,'Dora')
        dialog_show(quest+": Dora","Sender Response",deliveryquest_accept,quest)
    # Cilia
    else:
        savegame_set_key('Selected Fairies',quest,'Cilia')
        dialog_show(quest+": Cilia","Sender Response",deliveryquest_accept,quest)

#Ask if the player will accept the quest.
def deliveryquest_accept(last_group,last_key,options,quest):
    dialog_show(quest,"Player Accept Quest",deliveryquest_begin,quest,False)

#Ask if the player will reactivate the quest.
def deliveryquest_reactivate(last_group,last_key,options,quest):
    dialog_show(quest,"Player Reactivate Quest",deliveryquest_begin,quest,True)

# If the player responded Yes to accepting the quest, make it the active quest and place the target. Give the player the delivery item.
def deliveryquest_begin(last_group,last_key,options,quest,reactivate):
    global DELIVERYQUESTS
    questdata=DELIVERYQUESTS[quest]
    if options[0] != 0:
        if savegame_string('Quest Status',quest) is False:
            savegame_set_key('Quest Status',quest,'Declined')
        if reactivate is False:
            dialog_show(quest+": "+savegame_string('Selected Fairies',quest),"Decline",None)
    else:
        savegame_set_key('General','Active Quest',quest)
        savegame_set_key('Quest Status',quest,'Accepted')
        savegame_delete_pattern('Targets','Side Quest*','*')
        savegame_set_key(
            'Targets',
            'Side Quest '+str(questdata['Sender Coordinate'][0])+','+str(questdata['Sender Coordinate'][1]),
            str(questdata['Receiver Coordinate'][0])+','+str(questdata['Receiver Coordinate'][1])+',4,'+quest+": "+savegame_string('Selected Fairies',quest)+',Target Description 0'
        )
        map_target_refresh()
        map_reveal(questdata['Receiver Coordinate'][0], questdata['Receiver Coordinate'][1],True)
        map_roomtype_unlock(questdata['Receiver Coordinate'][0], questdata['Receiver Coordinate'][1])
        map_roomtype_reveal(questdata['Receiver Coordinate'][0], questdata['Receiver Coordinate'][1])
        if reactivate is False:
            if 'Item' in questdata:
                savegame_set_key('Inventory',questdata['Item'],savegame_value('Inventory',questdata['Item'])+1)
            if 'Upfront Rewards' in questdata:
                for reward in questdata['Upfront Rewards']:
                    savegame_set_key('Inventory',reward,savegame_value('Inventory',reward)+1)
            inventory_refresh(True)
            dialog_show(quest+": "+savegame_string('Selected Fairies',quest),"Accept",None)

# Trigger this function when the player talks to the reciever
def deliveryquest_receiver(quest):
    # If the quest is already complete
    if savegame_string('Quest Status',quest) == 'Completed':
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Receiver Talk Again',None)
    # If the quest is active
    elif savegame_string('Quest Status',quest) == 'Accepted':
        deliveryquest_complete(quest)
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Receiver Complete',None)
    # If the quest have never been accepted
    else:
        dialog_show(quest,'Receiver Opening',None)

def deliveryquest_complete(quest):
    global DELIVERYQUESTS
    questdata=DELIVERYQUESTS[quest]
    if 'Item' in questdata:
        savegame_set_key(
            'Inventory',questdata['Item'],
            max(savegame_value('Inventory',questdata['Item'])-1,0)
        )
    if 'Rewards' in questdata:
        for reward in questdata['Rewards']:
            savegame_set_key('Inventory',reward,savegame_value('Inventory',reward)+1)
    inventory_refresh(True)
    if 'Press Button' in questdata:
        savegame_set_key(str(room_x())+','+str(room_y())+' Buttons',questdata['Press Button'],'Pressed')
        sprite_greyswitch_set_state(questdata['Press Button'],True)
        sprite_door_open(questdata['Press Button'],False)
    map_roomtype_delete(room_x(),room_y())
    map_roomtype_delete(questdata['Sender Coordinate'][0],questdata['Sender Coordinate'][1])
    savegame_set_key('Quest Status',quest,'Completed')
    # Close the quest if this is the open one
    if savegame_string('General','Active Quest') == quest:
        quest_close()

################################################## Fairyless Custom Quest ##################################################
# Data about individual quests
FAIRYLESS_CUSTOMQUESTS = {
    "Tova is Gone": {
        'Quest Coordinate': [25,12],
        'Targets': [[23,9,'Target Description 0']]
    },
    "The Family Murder": {
        'Quest Coordinate': [18,16],
        'Targets': [[18,18,'Target Description 0']]
    }
}

# Trigger this function to start a custom quest
def fairyless_customquest_npc(quest):
    # If the quest is already complete
    if (savegame_string('Quest Status',quest) == 'Completed'):
        dialog_show(quest,'Already Complete',None)
    # This is the active quest
    elif(savegame_string('General','Active Quest') == quest):                                                                 
        dialog_show(quest,"Already Active",None)
    # This quest is inactive but have been accepted before.
    elif savegame_string('Quest Status',quest) == 'Accepted':
        dialog_show(quest,'Player Reactivate Quest',fairyless_customquest_begin,True)
    # This quest is inactive but have been declined before.
    elif savegame_string('Quest Status',quest) == 'Declined':
        dialog_show(quest,'Reconsider',fairyless_customquest_accept)
    # The quest is inactive 
    else:
        dialog_show(quest,'Opening',fairyless_customquest_accept)

#Ask if the player will accept the quest.
def fairyless_customquest_accept(quest,last_key,options):
    dialog_show(quest,"Player Accept Quest",fairyless_customquest_begin,False)

# If the player responded Yes to accepting the quest, make it the active quest and place the targets.
def fairyless_customquest_begin(quest,last_key,options,skip_dialog):
    global FAIRYLESS_CUSTOMQUESTS
    questdata=FAIRYLESS_CUSTOMQUESTS[quest]
    if options[0] != 0:
        if savegame_string('Quest Status',quest) is False:
            savegame_set_key('Quest Status',quest,'Declined')
        if not skip_dialog:
            dialog_show(quest,"Decline",None)
    else:
        quest_close()
        savegame_set_key('General','Active Quest',quest)
        savegame_set_key('Quest Status',quest,'Accepted')
        for target in questdata['Targets']:
            if not iszero(savegame_value('Map',str(target[0])+","+str(target[1])+" Type")):
                map_reveal(target[0], target[1],True)
                map_roomtype_unlock(target[0], target[1])
                map_roomtype_reveal(target[0], target[1])
                savegame_set_key(
                    'Targets',
                    'Side Quest '+str(target[0])+','+str(target[1]),
                    str(target[0])+','+str(target[1])+',4,'+quest+','+target[2]
                )
        map_target_refresh()
        if not skip_dialog:
            dialog_show(quest,"Accept",None)

# Trigger this when the custom quest completes
def fairyless_customquest_complete(quest):
    global FAIRYLESS_CUSTOMQUESTS
    questdata=FAIRYLESS_CUSTOMQUESTS[quest]
    map_roomtype_delete(questdata['Quest Coordinate'][0],questdata['Quest Coordinate'][1])
    for target in questdata['Targets']:
        map_roomtype_delete(target[0],target[1])
    savegame_set_key('Quest Status',quest,'Completed')
    # Close the quest if this is the open one
    if savegame_string('General','Active Quest') == quest:
        quest_close()

################################################## Custom Quest ##################################################
# Data about individual quests
CUSTOMQUESTS = {
    "Tova's Friend": {
        'Quest Coordinate': [25,13],
        'Targets': [[25,17,'Target Description 0']]
    },
    'Introducing Wangleflower': {
        'Quest Coordinate': [28,4],
        'Targets': [[30,0,'Target Description 0']]
    }
}

# Trigger this function to start a custom quest
def customquest_npc(quest):
    # If the quest is already complete
    if savegame_string('Quest Status',quest) == 'Completed':
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Already Complete',None)
    # This quest is already active
    elif savegame_string('General','Active Quest') == quest:
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),"Already Active",None)
    # If the quest is started since before but not active
    elif savegame_string('Quest Status',quest) == 'Accepted':
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Player Reactivate Quest',customquest_begin,quest,True)
    # If the quest has previously been declined        
    elif savegame_string('Quest Status',quest) == 'Declined':
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest),'Reconsider',customquest_accept,quest)
    # The quest is inactive 
    else:
        dialog_show(quest,'Opening',customquest_respond)

# Store which fairy that was selected, and respond.
def customquest_respond(quest,last_key,options):
    # A character has been pre-selected by a room script for this quest.
    if savegame_string('Selected Fairies',quest) is not False:
        dialog_show(quest+": "+savegame_string('Selected Fairies',quest), "Response", customquest_accept, quest)
    # Dora
    elif options[0] == 0:
        savegame_set_key('Selected Fairies',quest,'Dora')
        dialog_show(quest+": Dora","Response",customquest_accept,quest)
    # Cilia
    else:
        savegame_set_key('Selected Fairies',quest,'Cilia')
        dialog_show(quest+": Cilia","Response",customquest_accept,quest)

# Ask the player if the quest should be accepted.
def customquest_accept(last_group,last_key,options,quest):
    dialog_show(quest,"Player Accept Quest",customquest_begin,quest,False)

# If the player responded Yes to accepting the quest, make it the active quest and place the targets.
def customquest_begin(last_group,last_key,options,quest,skip_dialog):
    global CUSTOMQUESTS
    questdata=CUSTOMQUESTS[quest]
    if options[0] != 0:
        if savegame_string('Quest Status',quest) is False:
            savegame_set_key('Quest Status',quest,'Declined')
        if not skip_dialog:
            dialog_show(quest+": "+savegame_string('Selected Fairies',quest),"Decline",None)
    else:
        quest_close()
        savegame_set_key('General','Active Quest',quest)
        savegame_set_key('Quest Status',quest,'Accepted')
        for target in questdata['Targets']:
            if not iszero(savegame_value('Map',str(target[0])+","+str(target[1])+" Type")):
                map_reveal(target[0], target[1],True)
                map_roomtype_unlock(target[0], target[1])                
                map_roomtype_reveal(target[0], target[1])
                savegame_set_key(
                    'Targets',
                    'Side Quest '+str(target[0])+','+str(target[1]),
                    str(target[0])+','+str(target[1])+',4,'+quest+": "+savegame_string('Selected Fairies',quest)+','+target[2]
                )
        map_target_refresh()
        if not skip_dialog:
            dialog_show(quest+": "+savegame_string('Selected Fairies',quest),"Accept",None)

# Trigger this when the custom quest completes
def customquest_complete(quest):
    global CUSTOMQUESTS
    questdata=CUSTOMQUESTS[quest]
    map_roomtype_delete(questdata['Quest Coordinate'][0],questdata['Quest Coordinate'][1])
    for target in questdata['Targets']:
        map_roomtype_delete(target[0],target[1])
    savegame_set_key('Quest Status',quest,'Completed')
    # Close the quest if this is the open one
    if savegame_string('General','Active Quest') == quest:
        quest_close()

################################################## Speak Once ##################################################

def dialog_speakonce(group, item, callback = None, *args):
    if savegame_string('Speak Once', group + ':' + item) is False:
        savegame_set_key('Speak Once', group + ':' + item, 1)
        dialog_show(group, item, callback, *args)
        return True
    else:
        return False